/* Zadatak 4D:

  Napisite funkciju izgradi koja prima string ispis u kojem je zapisana
  rijec. Funkcija treba provjeriti da li se, u svakom zadnjem komadu
  te rijeci, znak 'g' pojavljuje manje ili jednako puta nego znak 'h',
  pri cemu u cijeloj rijeci treba biti jednak broj znakova 'g' i 'h'.
    Ako to vrijedi, funkcija treba u stringu zamijeniti svaki znak 'g'
  znakom '<', te svaki znak 'h' znakom '>'. U protivnom, funkcija
  ne mijenja string.
    Kao vrijednost, funkcija treba vratiti broj promijenjenih znakova,
  te kroz varijabilni argument pokazivac na promijenjeni znak najmanjeg
  indeksa, ako takav postoji, inace NULL.
  Ako je string duljine 0, funkcija treba vratiti 0 kao vrijednost, te
  NULL kroz varijabilni argument. Napisite primjer poziva funkcije.

  Primjer: String "ghg-ghh-" zadovoljava trazeni uvjet, a string
  "hgg-ghh-" ne zadovoljava.
*/

#include<stdio.h>

    /* Trazena funkcija iz zadatka. */

int izgradi(char *ispis, char **pp_promijenjeni_znak)
{
    int i, j, broj_pojavljivanja_g = 0, broj_pojavljivanja_h = 0;

    *pp_promijenjeni_znak = NULL;
    if (ispis[0] == '\0') return 0;
        /* Nadji indeks j zadnjeg znaka. */
    for (j = 0; ispis[j] != '\0'; ++j) {}
    --j;
        /* Obrada zadnjih komada unatrag, do pocetka. */
    for (i = j; i >= 0; --i) {
        if (ispis[i] == 'g') ++broj_pojavljivanja_g;
        if (ispis[i] == 'h') ++broj_pojavljivanja_h;
        if (broj_pojavljivanja_g > broj_pojavljivanja_h) return 0;
    }
        /* Promjena znakova. */
    for (i = j; i >= 0; --i) {
        if (ispis[i] == 'g') {ispis[i] = '<';
            *pp_promijenjeni_znak = &ispis[i];
        }
        if (ispis[i] == 'h')  ispis[i] = '>';
    }

    return broj_pojavljivanja_g + broj_pojavljivanja_h;
}

    /* Glavni program za demo. */

int main (void)
{
    char tekst1[] = "ghg-ghh-", tekst2[] = "hgg-ghh-";
    int n;    /* Vrijednost funkvije. */
    char *p;  /* Pokazivac = varijabilni argument za funkciju. */

        /* Primjer 1. */
    printf("Primjer 1:\n");
    printf("  Rijec prije poziva: %s\n", tekst1);
    n = izgradi(tekst1, &p);
    printf("  Rijec nakon poziva: %s\n", tekst1);
    printf("  Broj promijenjenih znakova = %d\n", n);
    printf("  Adresa pocetka rijeci = %p\n", tekst1);
    printf("  Adresa prvog promijenjenog znaka = %p\n", p);
    if (p != NULL)
        printf("  Indeks prve promjene = %d\n", (int)(p - tekst1));

    printf("\n");

        /* Primjer 2. */
    printf("Primjer 2:\n");
    printf("  Rijec prije poziva: %s\n", tekst2);
    n = izgradi(tekst2, &p);
    printf("  Rijec nakon poziva: %s\n", tekst2);
    printf("  Broj promijenjenih znakova = %d\n", n);
    printf("  Adresa pocetka rijeci = %p\n", tekst2);
    printf("  Adresa prvog promijenjenog znaka = %p\n", p);
    if (p != NULL)
        printf("  Indeks prve promjene = %d\n", (int)(p - tekst2));

    return 0;
}
